##     RunIt
##     This is a little program to run a single command in the ROX environment.
##     It runs as an Applet or as an Application
##     Copyright (C) 2002  John Williams and Robert Lowe

##     This program is free software; you can redistribute it and/or modify
##     it under the terms of the GNU General Public License as published by
##     the Free Software Foundation; either version 2 of the License, or
##     (at your option) any later version.

##     This program is distributed in the hope that it will be useful,
##     but WITHOUT ANY WARRANTY; without even the implied warranty of
##     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##     GNU General Public License for more details.

##     You should have received a copy of the GNU General Public License
##     along with this program; if not, write to the Free Software
##     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

from gtk import *
from GDK import *
import runit

def CreateMainWindow():
	# create the main window
	mainWindow = GtkWindow()
	mainWindow.connect("destroy", mainquit)
	mainWindow.connect("delete_event", mainquit)
	mainWindow.set_usize(250, 100)
	mainWindow.set_title("RunIt")
	mainWindow.set_border_width(10)

	# create the main box
	mainBox = GtkHBox(FALSE, 0)
	mainWindow.add(mainBox)
	mainBox.show()

	# create entry
	commandEntry = GtkEntry()
	commandEntry.connect("activate", runit.ExecIt, commandEntry)
	commandEntry.connect("key-press-event", runit.keypress_handler)
	commandEntry.set_max_length(1024)
        vbox=GtkVBox()
	vbox.pack_start(commandEntry)
	vbox.pack_start(runit.term_button, expand=0, fill=0)
	mainBox.pack_start(vbox)
	commandEntry.grab_focus()
	commandEntry.show()
        vbox.show()
	runit.term_button.show()

	# create box for the buttons
	buttonBox = GtkVBox(TRUE, 10)
	mainBox.pack_end(buttonBox)
	buttonBox.show()

	# create the cancel button
	cancelButton = GtkButton("Cancel")
	cancelButton.connect("clicked", mainquit)
	buttonBox.pack_end(cancelButton)
	cancelButton.show()

	# create the run button
	runButton = GtkButton("Run")
	runButton.connect("clicked", runit.ExecIt, commandEntry)
	buttonBox.pack_start(runButton)
	runButton.show()

	# create separator between buttons and edit box
	separator = GtkVSeparator()
	mainBox.pack_start(separator, expand=TRUE)
	separator.show()

	mainWindow.show()

def main():
	CreateMainWindow()
	mainloop()


if __name__ == '__main__':
	main()
