##     RunIt
##     This is a little program to run a single command in the ROX environment.
##     It runs as an Applet or as an Application
##     Copyright (C) 2002  John Williams and Robert Lowe

##     This program is free software; you can redistribute it and/or modify
##     it under the terms of the GNU General Public License as published by
##     the Free Software Foundation; either version 2 of the License, or
##     (at your option) any later version.

##     This program is distributed in the hope that it will be useful,
##     but WITHOUT ANY WARRANTY; without even the implied warranty of
##     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##     GNU General Public License for more details.

##     You should have received a copy of the GNU General Public License
##     along with this program; if not, write to the Free Software
##     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

import os
import sys
import string
from gtk import *
import GDK
import findrox
import signal
from rox import support
from rox import choices

applet=0
command_list=[]
cindex=0
term_button=GtkCheckButton(label='Run in xterm')
choice_path=choices.save('RunIt', 'history')

#load up the history
try:
     f=open(choice_path, 'r')
except:
     f=0 

if f:
     history=f.readlines()
     his_index=len(history)
     f.close()
else:
     history=[]
     his_index=-1

his_len=len(history)

#take off new line characters
for i in range(0, his_len):
     history[i]=history[i][0:-1]


def borked(command):
	# something is wrong with the command so display an error msg
	print "DEBUG: Can't execute", command
	errorWindow = GtkWindow()
	errorWindow.connect("destroy", mainquit)
	errorWindow.set_usize(275, 100)
	errorWindow.set_title("Whoops, something is borked")
	errorWindow.set_border_width(30)
        vbox=GtkVBox()
        vbox.set_border_width(5)
        vbox.pack_start(GtkLabel('Could not execute: ' + command[0]), expand=0,
                        fill=0)
        button=GtkButton('Ok')
        button.connect("clicked", mainquit)
        vbox.pack_start(button, expand=0, fill=0) 
        errorWindow.add(vbox)
	errorWindow.show_all()
	

def ExecIt(window, entry):
	global applet, command_list, cindex, term_button, choice_path, history
	global his_len
	# pull the command from the edit box
	text = entry.get_text()

	try:
		f=open(choice_path, 'a')
        except:
		f=0

        #write history file
	if f :
		f.write(text+'\n')
		f.close()

        history.append(text)
	his_index=len(history)+1
	his_len=his_index -1

	# clean it up
	command = text.strip()

	# if there is no command, empty the editable of whitespace,
	# return focus to the editable, and wait for another try
	if len(command) == 0:
		entry.delete_text(0, len(text))
		entry.insert_text("")
		entry.grab_focus()
		return

	# break on whitespace into a list of strings
	command = string.split(command)
	if term_button.get_active():
	  term_button.set_active(0)
	  command=['xterm', '-e']+command

	# go for the execvp
	#do the applet based spawning, handles zombies and all
	if applet:
          if os.fork():
            entry.delete_text(0, -1)
          else:
	    try:
              os.execvp(command[0], command)
	    except:
              os.execvp(support.app_dir + '/ErrorRun', ['ErrorRun'] + command)

	#do the application type stuff
        else:
          try:
            os.execvp(command[0], command)
          except:
	    borked(command)
         
def cleanup_handler():
  "cleans up zombies"

  while 1 :
    try: 
      if os.waitpid(-1, os.WNOHANG)[0] ==0:
        break
    except: 
        break
    pass

  return 1


def keypress_handler(widget, event):
	"hanldes keypresses"

	global history, his_index, his_len

 	if event.keyval==GDK.Up:
		widget.emit_stop_by_name('key-press-event')
 	        widget.delete_text(0, -1)
  		if his_index <0:
  			return 1

  		if his_index > his_len:
  			his_index=his_len

  		his_index-=1
  		if his_index < 0:
  			his_index=0

  		widget.insert_text(history[his_index])
		widget.set_position(len(history[his_index]))
  		return 1

 	if event.keyval==GDK.Down:
		widget.emit_stop_by_name('key-press-event')
 	        widget.delete_text(0, -1)
  		if his_index <0:
  			return 1
  		his_index+=1
		if his_index > his_len-1:
			return 1
  		widget.insert_text(history[his_index])
		widget.set_position(len(history[his_index]))
  		return 1

	return 0
			
